using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.IO;

namespace SampleAppForObjectRef
{
    public partial class Form1 : Form
    {
        private DataTable _dtTable;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
        private void ifgGridFrom_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowColSizing = AllowColSizing.None;
            e.Layout.ViewStyleBand = ViewStyleBand.Vertical;
            e.Layout.Override.CellClickAction = CellClickAction.RowSelect;
            e.Layout.Override.AllowDelete = Infragistics.Win.DefaultableBoolean.False;
            e.Layout.Override.AllowUpdate = Infragistics.Win.DefaultableBoolean.False;
            e.Layout.Override.AllowGroupBy = Infragistics.Win.DefaultableBoolean.False;
            e.Layout.AutoFitStyle = AutoFitStyle.ResizeAllColumns;
            foreach (UltraGridBand ugBand in e.Layout.Bands)
            {

                foreach (UltraGridColumn oCol in ugBand.Columns)
                {
                    if (oCol.Key.Equals("ValueMember", StringComparison.InvariantCultureIgnoreCase))
                    {
                        
                        oCol.Header.Caption = string.Empty;
                        //oCol.CellActivation = Activation.NoEdit;
                    }
                    else
                        oCol.Hidden = true;
                }
            }
        }

        private void ifgGridFrom_AfterSelectChange(object sender, AfterSelectChangeEventArgs e)
        {
            try
            {
                Cursor = Cursors.WaitCursor;
                if (ifgGridFrom.Selected.Rows.Count > 0)
                    PopulateFinalItemSelection();
                else
                    ifgGridFinalItemSelection.DataSource = null;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                SelectUnSelectAll(ifgGridFinalItemSelection, true);
                Cursor = Cursors.Default;
            }
        }
        /// <summary>
        /// Select / Deselect all Items from the Grid
        /// </summary>
        /// <param name="ugGrid">Set the source grid</param>
        /// <param name="bSelect">Set the bSelect value whether Select / Deselect </param>

        private void SelectUnSelectAll(UltraGrid ugGrid, bool bSelect)
        {
            UltraGridRow[] ugRows = ugGrid.Rows.All as UltraGridRow[];
            if (bSelect)
                ugGrid.Selected.Rows.AddRange(ugRows);
            else
                ugGrid.Selected.Rows.Clear();

            //ugGrid.ActiveRow = null;
        }



        /// <summary>
        /// Get the Filtered Table based on filtered condition and output column
        /// </summary>
        /// <param name="dtUnfilteredTable">Set the Unfiltered table</param>
        /// <param name="filterString">Set the Filter string</param>
        /// <param name="columnName">Set the ColumnName</param>
        /// <returns>returns the Filtered Table based on filter condition</returns>
        private DataTable GetFilteredTable(DataTable dtUnfilteredTable, string filterString, string columnName)
        {
            try
            {
                DataTable dtTempUnfilteredTable = dtUnfilteredTable.Copy(); //Copy the Table
                dtTempUnfilteredTable.DefaultView.RowFilter = filterString; //Assign the Filter string to the Row Filter
                if (string.IsNullOrEmpty(columnName)) //Check whether any specific column specified or not
                    return dtTempUnfilteredTable.DefaultView.ToTable(dtUnfilteredTable.TableName); //Convert the View into table

                //If Specific column Specified Column specified, then get the table with distinct column value
                string[] columnNames = new string[1];
                columnNames[0] = columnName;
                return dtTempUnfilteredTable.DefaultView.ToTable(dtUnfilteredTable.TableName, true, columnNames); //Get the table with distinct column value  
            }
            catch (Exception ex)
            {
                
                throw;
            }
        }

        private void PopulateFinalItemSelection()
        {
            string filterString = ToSqlFilterString("ValueMember", ifgGridFrom);
            DataTable dtFinalItemSelection = GetFilteredTable(_dtTable.Copy(), filterString, null);
            ifgGridFinalItemSelection.DataSource = dtFinalItemSelection.Copy();
        }
        public string ToSqlFilterString(string fieldName, UltraGrid ugGrid)
        {
            if (ugGrid.Selected.Rows.Count == 0)
                return string.Empty;

            StringBuilder filterBuffer = new StringBuilder(256);

            if (ugGrid.Selected.Rows.Count == 1)
            {
                UltraGridRow ugRow = ugGrid.Selected.Rows[0];
                string value = ugRow.Cells[fieldName].Value.ToString();
                value = value.Replace("'", "''");
                if (value.Equals("[UNASSIGNED]", StringComparison.InvariantCultureIgnoreCase))
                {
                    //filterBuffer.AppendFormat("[{0}] IS NULL OR len([{0}])=0", FieldName);
                    #region code commented by vijay on 16/04/2009
                    //if(_dataTypeCode== DataTypeCode.String)
                    //    filterBuffer.AppendFormat("[{0}] IS NULL OR len([{0}])=0", FieldName);
                    //else
                    //    filterBuffer.AppendFormat("[{0}] IS NULL", FieldName);
                    #endregion
                    #region code added by vijay on 16/04/2009
                    //if (fieldName.Equals("FAOverAllRootCause", StringComparison.InvariantCultureIgnoreCase))
                    //{
                    if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.String"))
                        filterBuffer.AppendFormat("([{0}] IS NULL OR len([{0}])=0 OR [{0}] = '[UNASSIGNED]')", fieldName);
                    else
                        filterBuffer.AppendFormat("([{0}] IS NULL OR [{0}] = '[UNASSIGNED]')", fieldName);
                    //}
                    //else
                    //{
                    //    if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.String"))
                    //        filterBuffer.AppendFormat("[{0}] IS NULL OR len([{0}])=0", fieldName);
                    //    else
                    //        filterBuffer.AppendFormat("[{0}] IS NULL", fieldName);
                    //}

                    #endregion
                }
                else
                {

                    if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.String"))
                        filterBuffer.AppendFormat("[{0}] = \'{1}\'", fieldName, value);

                    else if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.Decimal"))
                        filterBuffer.AppendFormat("[{0}] = {1}", fieldName, value);

                    else if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.Boolean"))
                        filterBuffer.AppendFormat("[{0}] = \'{1}\'", fieldName, value);
                }

            }
            else
            {
                filterBuffer.AppendFormat("[{0}] IN ( ", fieldName);
                bool isFirst = true;
                string nullValue = string.Empty;
                foreach (UltraGridRow ugRow in ugGrid.Selected.Rows)
                {
                    string value = ugRow.Cells[fieldName].Value.ToString();
                    value = value.Replace("'", "''");
                    if (value.Equals("[UNASSIGNED]", StringComparison.InvariantCultureIgnoreCase))
                    {
                        if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.String"))
                            nullValue = string.Format("([{0}] IS NULL OR len([{0}])=0 OR [{0}] = '[UNASSIGNED]') ", fieldName);
                        else
                            nullValue = string.Format("([{0}] IS NULL OR [{0}] = '[UNASSIGNED]')", fieldName);


                        continue;
                    }
                    if (isFirst)
                    {
                        if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.String"))
                            filterBuffer.AppendFormat("\'{0}\'", value);

                        else if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.Decimal"))
                            filterBuffer.AppendFormat("{0}", value);
                        else if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.Boolean"))
                            filterBuffer.AppendFormat("\'{0}\'", value);

                        isFirst = false;
                    }
                    else
                    {
                        if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.String"))
                            filterBuffer.AppendFormat(", \'{0}\'", value);

                        else if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.Decimal"))
                            filterBuffer.AppendFormat(", {0}", value);
                        else if (ugRow.Cells[fieldName].Column.DataType.ToString().Equals("System.Boolean"))
                            filterBuffer.AppendFormat(", \'{0}\'", value);
                    }

                }
                filterBuffer.Append(")");
                if (!string.IsNullOrEmpty(nullValue))
                {
                    filterBuffer.Append(" OR " + nullValue + ")");
                    filterBuffer.Insert(0, "(");

                }
            }
            return filterBuffer.ToString();

        }



        private void LoadDataSet()
        {
            DataSet dsTemp = new DataSet();
            dsTemp.ReadXml(Path.Combine(Application.StartupPath, "EINs.xml"));

            _dtTable = dsTemp.Tables[0].Copy();
            //_dtTable.ReadXml(@"C:\EINs.xml");
            _dtTable.AcceptChanges();
        }
        private void ifgBtnReload_Click(object sender, EventArgs e)
        {
            LoadDataSet();
            ifgGridFrom.DataSource = _dtTable.Copy();
            //ifgGridFinalItemSelection.DataSource = _dtTable.Copy();

        }
    }
}